package net.froemling.bsremote;

import net.froemling.bsremote.GamePadActivity;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.InterfaceAddress;
import java.net.NetworkInterface;
import java.net.SocketAddress;
import java.net.SocketException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Timer;
import java.util.TimerTask;
import javax.jmdns.JmDNS;
import javax.jmdns.ServiceEvent;
import javax.jmdns.ServiceInfo;
import javax.jmdns.ServiceListener;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import net.froemling.bsremote.WorkerThread;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager.NameNotFoundException;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.net.wifi.WifiManager.MulticastLock;
import android.os.Bundle;
import android.os.Looper;
import android.os.SystemClock;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;


public class ScanActivity extends Activity implements ServiceListener {

	static public Context mContext = null;
	
	public final static boolean debug = false;

	public final static String TAG = "SCAN";
	public final static String TOUCH_ABLE_TYPE = "_bsremote._udp.local.";
	public final static String HOSTNAME = "bsremote";

	static final int BS_PACKET_REMOTE_GAME_QUERY = 8;
	static final int BS_PACKET_REMOTE_GAME_RESPONSE = 9;

	private static JmDNS _zeroConf = null;
	private static MulticastLock _mLock = null;

	private Timer _processTimer;

	private WorkerThread _scannerThread;
	private WorkerThread _stopperThread;
	private WorkerThread _readThread;

	private DatagramSocket _scannerSocket;

	class _ServerEntry{
		InetAddress address;
		int port;
		long lastPingTime;
	}

	class ObjRunnable<T> implements Runnable{
		T obj;
		public ObjRunnable(T objIn){
			obj = objIn;
		}
		public void run(){
		}
	}

	Map<String,_ServerEntry> _serverEntries;

	int _listEmptyTime;

	class ScanKillRunnable implements Runnable {
		JmDNS zc;
		ScanKillRunnable(JmDNS zcIn) { zc = zcIn; }
		public void run(){
			zc.removeServiceListener(TOUCH_ABLE_TYPE, ScanActivity.this);
			try {zc.close();}
			catch (IOException e) {
				LogThread.log("Error in ScanKillRunnable",e);
			}
		}
	}

	protected void _startBonjourProbe() throws Exception {
		assert(Thread.currentThread() == _scannerThread);
		assert(_zeroConf == null);

		// figure out our wifi address, otherwise bail
		WifiManager wifi = (WifiManager) ScanActivity.this.getSystemService(Context.WIFI_SERVICE);
		WifiInfo wifiinfo = wifi.getConnectionInfo();
		int intaddr = wifiinfo.getIpAddress();
		if (intaddr != 0) { // Only worth doing if there's an actual wifi
			byte[] byteaddr = new byte[] { (byte) (intaddr & 0xff), (byte) (intaddr >> 8 & 0xff),
					(byte) (intaddr >> 16 & 0xff), (byte) (intaddr >> 24 & 0xff) };
			InetAddress addr = InetAddress.getByAddress(byteaddr);
			_zeroConf = JmDNS.create(addr);
			_zeroConf.addServiceListener(TOUCH_ABLE_TYPE, ScanActivity.this);
		}
	}

	public static JmDNS getZeroConf() {
		return _zeroConf;
	}

	public void serviceAdded(ServiceEvent event) {
		//availableServersChangedHandler.obtainMessage(BONJOUR_ADD, event.getName()).sendToTarget();
		runOnUiThread(new ObjRunnable<String>(event.getName()){
			public void run(){
				_adapter.notifyBonjourFound(obj);
			}
		});
	}

	public void serviceResolved(ServiceEvent event) {
	}

	public void serviceRemoved(ServiceEvent event) {
		//availableServersChangedHandler.obtainMessage(BONJOUR_REMOVE, event.getName()).sendToTarget();
		runOnUiThread(new ObjRunnable<String>(event.getName()){
			public void run(){
				_adapter.notifyBonjourLost(obj);
			}
		});

	}

	public final static int DONE = 3;

	//   public Handler availableServersChangedHandler = new Handler() {
	//	   @Override
	//	   public void handleMessage(Message msg) {
	//			assert(Looper.getMainLooper().getThread() == Thread.currentThread());
	//
	//		   if (msg.obj != null) {
	//			   if (msg.what == BONJOUR_ADD){
	//				   _adapter.notifyBonjourFound((String) msg.obj);
	//			   }
	//			   else if (msg.what == BONJOUR_REMOVE){
	//				   _adapter.notifyBonjourLost((String) msg.obj);
	//			   }
	//		   }
	//	   }
	//   };

	protected ListView list;
	protected LibraryAdapter _adapter;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		if (debug) Log.v(TAG,"onCreate()");
		super.onCreate(savedInstanceState);

		mContext = this.getApplicationContext();
		
		setContentView(R.layout.gen_list);

		_scannerThread = new WorkerThread();
		_scannerThread.start();

		_stopperThread = new WorkerThread();
		_stopperThread.start();


		this._adapter = new LibraryAdapter(this);
		this.list = (ListView) this.findViewById(android.R.id.list);
		this.list.addHeaderView(_adapter.footerView, null, false);
		this.list.setAdapter(_adapter);

//		Button button = (Button) findViewById(R.id.button1);
//		if (button != null){
//			Log.v(TAG,"FOUND BUTTON");
//			button.setOnClickListener(new View.OnClickListener() {
//				public void onClick(View v) {
//					String[] fakeAddrs = {};
//					Intent myIntent = new Intent(ScanActivity.this, GamePadActivity.class);
//					myIntent.putExtra("connectAddrs", fakeAddrs);
//					myIntent.putExtra("connectPort", 1234);
//					startActivity(myIntent);            		
//				}
//			});
//		}

		
		this.list.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				String name = ((TextView) view.findViewById(android.R.id.text1)).getText().toString();

				_scannerThread.doRunnable(new ObjRunnable<String>(name){
					public void run(){
						// if we've got this in our non-bonjour entries, use that
						if (_serverEntries.containsKey(obj)){
							_ServerEntry se = _serverEntries.get(obj);
							Intent myIntent = new Intent(ScanActivity.this, GamePadActivity.class);
							myIntent.putExtra("connectAddrs", new String[] {se.address.getHostName()});
							myIntent.putExtra("connectPort",se.port);
							myIntent.putExtra("newStyle",true);

							startActivity(myIntent);            		

						}
						else{
							JmDNS zc = getZeroConf(); 
							if (zc != null){
								ServiceInfo serviceInfo = zc.getServiceInfo(TOUCH_ABLE_TYPE, obj,5000);
								if (serviceInfo != null){
									Intent myIntent = new Intent(ScanActivity.this, GamePadActivity.class);
									Log.v(TAG,"USING ADDRS "+serviceInfo.getHostAddresses());
									myIntent.putExtra("connectAddrs", serviceInfo.getHostAddresses());
									myIntent.putExtra("connectPort", serviceInfo.getPort());
									myIntent.putExtra("newStyle",false);
									startActivity(myIntent);            		
								}
							}
						}

					}
				});

				return;
			}
		});
	}
	@Override
	public void onDestroy() {
		if (debug) Log.v(TAG,"onDestroy()");
		super.onDestroy();
		// have the worker threads shut themselves down
		_scannerThread.doRunnable(new Runnable() {
			public void run() {
				_scannerThread.getLooper().quit();
				_scannerThread = null;

				// have the worker threads shut themselves down
				_stopperThread.doRunnable(new Runnable() {
					public void run() {
						//Log.v(TAG,"STOPPER THREAD DYING");
						_stopperThread.getLooper().quit();
						_stopperThread = null;
					}
				});

			}
		});
	}

	@Override
	public void onPause() {
		super.onPause();
	}

	@Override
	public void onResume() {
		super.onResume();
	}

	@Override
	public void onStart() {
		if (debug) Log.v(TAG,"onStart()");
		super.onStart();

		// hold a multicast lock while we're active so that we process multicast packets
		// FIXME - shouldnt be necessary with new simple broadcast system
		WifiManager wifi = (WifiManager) ScanActivity.this.getSystemService(Context.WIFI_SERVICE);
		_mLock = wifi.createMulticastLock("BombSquad Remote lock");
		_mLock.setReferenceCounted(true);
		_mLock.acquire();
		_adapter._knownGames.clear();
		_adapter._knownGamesBonjour.clear();
		_adapter.notifyDataSetChanged();

		_serverEntries = new HashMap<String,_ServerEntry>();

		try {
			_scannerSocket = new DatagramSocket();
			_scannerSocket.setBroadcast(true);
		} catch (SocketException e1) {
			LogThread.log("Error setting up scanner socket",e1);
		}

		// start up our bonjour probe (FIXME; remove this)
		_scannerThread.doRunnable(new Runnable() {
			public void run() {
				try {ScanActivity.this._startBonjourProbe();}
				catch (Exception e) {
					LogThread.log("Error starting bonjour probe",e);
				}
			}
		});

		_readThread = new WorkerThread();
		_readThread.start();

		// all the read-thread does is wait for data to come in
		// and pass it to the process-thread
		_readThread.doRunnable(new Runnable() {
			public void run() {
				while (true) {
					try {
						byte[] buf = new byte[256];
						DatagramPacket packet = new DatagramPacket(buf,buf.length);
						_scannerSocket.receive(packet);
						abstract class PacketRunnable implements Runnable {
							DatagramPacket p;
							PacketRunnable(DatagramPacket pIn) {
								p = pIn;
							}
							public abstract void run();
						}
						_scannerThread.doRunnable(new PacketRunnable(packet) {
							public void run() {

								// if this is a game response packet...
								if (p.getData().length > 1 && p.getData()[0] == BS_PACKET_REMOTE_GAME_RESPONSE){
									// extract name
									String s = new String(Arrays.copyOfRange(p.getData(),1,p.getLength()));

									// if this one isnt on our list, add it and inform the ui of its existence
									if (!_serverEntries.containsKey(s)){
										_serverEntries.put(s,new _ServerEntry());
										// hmm should we store its address only when adding or every time
										// we hear from them?..
										_serverEntries.get(s).address = p.getAddress();
										_serverEntries.get(s).port = p.getPort();
										runOnUiThread(new ObjRunnable<String>(s){
											public void run(){_adapter.notifyFound(obj);}
										});
									}
									_serverEntries.get(s).lastPingTime = SystemClock.uptimeMillis();
								}
							}
						});

					} catch (IOException e) {
						// assuming this means the socket is closed..
						_readThread.getLooper().quit();
						_readThread = null;
						break;
					} catch (ArrayIndexOutOfBoundsException e) {
						LogThread.log("Got excessively sized datagram packet",e);
					}
				}
			}
		});

		// start our timer to send out query packets, etc
		_processTimer = new Timer();
		_processTimer.schedule(new TimerTask() {			
			@Override
			public void run() {

				// when this timer fires, tell our process thread to run
				_scannerThread.doRunnable(new Runnable() {
					public void run() {

						// send broadcast packets to all our network interfaces to find games
						try {

							byte[] sendData = new byte[1];
							sendData[0] = BS_PACKET_REMOTE_GAME_QUERY;

							Enumeration<NetworkInterface> interfaces = NetworkInterface.getNetworkInterfaces();
							while (interfaces.hasMoreElements()) {
								NetworkInterface networkInterface = interfaces.nextElement();

								if (!networkInterface.isUp() || networkInterface.isLoopback()) {
									continue;
								}

								for (InterfaceAddress interfaceAddress : networkInterface.getInterfaceAddresses()) {
									InetAddress broadcast = interfaceAddress.getBroadcast();
									if (broadcast == null) {
										continue;
									}
									try {
										DatagramPacket sendPacket = new DatagramPacket(sendData, sendData.length, broadcast, 43210);
										_scannerSocket.send(sendPacket);
									} catch (Exception e) {
									}
								}
							}

						} catch (IOException ex) {
							LogThread.log("", ex);
						}

						// prune servers we haven't heard from in a while..
						long curTime = SystemClock.uptimeMillis();
						Iterator<Entry<String,_ServerEntry>> it = _serverEntries.entrySet().iterator();
						while (it.hasNext()) {
							Entry<String,_ServerEntry> thisEntry = it.next();
							long age = curTime-thisEntry.getValue().lastPingTime;
							if (age > 5000){
								runOnUiThread(new ObjRunnable<String>(thisEntry.getKey()){
									public void run(){_adapter.notifyLost(obj);}
								});
								it.remove();
							}
						}

						// ok, it seems that our JmDNS scanner occasionally gets 'stuck'
						// and doesn't show anything.  restarting it seems to fix this.
						// ...so if our list is empty for a while lets restart our scan
						if (_adapter.getCount() == 0){
							_listEmptyTime++;
							if (_listEmptyTime > 10){
								_listEmptyTime = 0;
								runOnUiThread(new Runnable() {
									public void run() {
										_restartBonjourScanning();
									}
								});
							}
						}
						else{
							_listEmptyTime = 0;
						}
					}});
			}
		}, 0, 1000);

	}

	@Override
	public void onStop() {
		if (debug) Log.v(TAG,"onStop()");
		super.onStop();
		if (_mLock != null) _mLock.release();
		_mLock = null;
		_scannerThread.doRunnable(new Runnable() {
			public void run() {
				JmDNS zc = _zeroConf;
				_zeroConf = null;
				if (zc != null){
					// this takes a while to shut down so let
					// our stopper thread chew on it in the bg
					_stopperThread.doRunnable(new ScanKillRunnable(zc));
				}
			}
		});
		_processTimer.cancel();
		_processTimer.purge();
		_scannerSocket.close();
	}

	//   @Override
	//	public boolean onCreateOptionsMenu(Menu menu) {
	//		// Inflate the menu; this adds items to the action bar if it is present.
	//		getMenuInflater().inflate(R.menu.act_scan, menu);
	//		return true;
	//	}
	private void _restartBonjourScanning(){
		// make sure we're running in the main thread
		assert(Looper.getMainLooper().getThread() == Thread.currentThread());
		// clear the list
		_adapter._knownGamesBonjour.clear();
		_adapter.notifyDataSetChanged();
		_scannerThread.doRunnable(new Runnable() {
			public void run() {
				// pass our current jmdns off to the stopper thread to shut down
				JmDNS zc = _zeroConf;
				_zeroConf = null;
				if (zc != null){
					_stopperThread.doRunnable(new ScanKillRunnable(zc));
				}
				// and have our scanner thread bring a new one up
				try {ScanActivity.this._startBonjourProbe();}	
				catch (Exception e) {
					LogThread.log("", e);
					//Log.e(TAG, String.format("Error restarting scan: %s", e.getMessage()));
				}
			}
		});
	}
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		if (item.getItemId() == R.id.menu_scan_refresh){
			_restartBonjourScanning();
			return true;
		}
		else return false;
	}

	public class LibraryAdapter extends BaseAdapter {
		protected Context _context;
		protected LayoutInflater _inflater;
		public View footerView;

		protected final LinkedList<String> _knownGamesBonjour = new LinkedList<String>();
		protected final LinkedList<String> _knownGames = new LinkedList<String>();

		public LibraryAdapter(Context context) {
			this._context = context;
			this._inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			this.footerView = _inflater.inflate(R.layout.item_network, null, false);
		}
		public void notifyLost(String gameName) {
			assert(Looper.getMainLooper().getThread() == Thread.currentThread());
			if (_knownGames.contains(gameName)) {
				_knownGames.remove(gameName);
				notifyDataSetChanged();
			}
		}
		public void notifyFound(String gameName) {
			assert(Looper.getMainLooper().getThread() == Thread.currentThread());
			if (!_knownGames.contains(gameName)) {
				_knownGames.add(gameName);
				notifyDataSetChanged();
			}
		}

		public void notifyBonjourLost(String gameName) {
			assert(Looper.getMainLooper().getThread() == Thread.currentThread());
			if (_knownGamesBonjour.contains(gameName)) {
				_knownGamesBonjour.remove(gameName);
				notifyDataSetChanged();
			}
		}
		public void notifyBonjourFound(String gameName) {
			assert(Looper.getMainLooper().getThread() == Thread.currentThread());
			if (!_knownGamesBonjour.contains(gameName)) {
				_knownGamesBonjour.add(gameName);
				notifyDataSetChanged();
			}
		}
		public Object getItem(int position) {
			if (!_knownGames.isEmpty()) return _knownGames.get(position);
			else return _knownGamesBonjour.get(position);
		}
		@Override
		public boolean hasStableIds() {
			return true;
		}
		public int getCount() {
			if (!_knownGames.isEmpty()) return _knownGames.size();
			else return _knownGamesBonjour.size();
		}
		public long getItemId(int position) {
			return position;
		}
		public View getView(int position, View convertView, ViewGroup parent) {
			if (convertView == null){
				convertView = _inflater.inflate(android.R.layout.simple_list_item_1, parent, false);
				TextView tv = (TextView)convertView.findViewById(android.R.id.text1);
				//tv.setGravity(Gravity.CENTER);
				tv.setPadding(40,0,0,0);
				tv.setTextColor(0xFFCCCCFF);
				tv.setTextSize(tv.getTextSize()*1.1f);
			}
			try {
				String gameName = (String) this.getItem(position);
				TextView tv = (TextView)convertView.findViewById(android.R.id.text1);
				tv.setText(gameName);

			} catch (Exception e) {
				LogThread.log("Problem getting zero-conf info",e);
				//Log.d(TAG, String.format("Problem getting ZeroConf information %s", e.getMessage()));
				((TextView) convertView.findViewById(android.R.id.text1)).setText("Unknown");
			}
			return convertView;
		}
	}
}


